
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////Mission Logic Functions

function SEF_MissionSelector()

	--Function to randomise the missions without duplication
	totalscenarios = 1 -- Increase this to however many scenarios are built into the map
	randomiser = math.random(1,totalscenarios)
	
	--Loop through the values of the various flags, and make sure they haven't already been activated.	
	for i = 1, totalscenarios, 1	do 
			--If the randomiser matches existing true flag, ie. the flag is already true, so the objective has been completed, get a new random number
			if (randomiser == i and trigger.misc.getUserFlag(i) >= 1) then
				--The flag value is 1 or greater, meaning the proposed mission has already completed. Restart function.
				SEF_MissionSelector()
			elseif (randomiser == i and trigger.misc.getUserFlag(i) == 0) then
				--Mission (i) has not been started, start it up then validate the target
				trigger.action.setUserFlag(i,1)
				SEF_MissionStarter(i)
				--trigger.action.outText("Validating Mission Number "..i.."", 15)
				SEF_MissionValidate()					
				return
			elseif (NumberOfCompletedMissions == totalscenarios) then
				trigger.action.outText("Ossetia War Has Been Successful", 15)
				SnowfoxUnitInterment = {}
				SEF_SaveUnitIntermentTableNoArgs()
				SnowfoxStaticInterment = {}
				SEF_SaveStaticIntermentTableNoArgs()
				return
			else
				-- Continue for loop until a match is found above				
			end			
	end	
end

function SEF_MissionValidate()
	--////WARNING - THIS WILL NOT BE ABLE TO VALIDATE SEA SHELF OBJECTS
	--Check the assigned target to check if it is alive or not
	if (AGTargetTypeStatic == false and AGMissionTarget ~= nil) then
		--TARGET IS NOT STATIC					
		if (GROUP:FindByName(AGMissionTarget):IsAlive() == true) then --(Group.getByName(AGMissionTarget):getSize() > 0) then
			--GROUP VALID
			trigger.action.outSound('That Is Our Target.ogg')
			trigger.action.outText(AGMissionBriefingText,15)			
		elseif (GROUP:FindByName(AGMissionTarget):IsAlive() == false or GROUP:FindByName(AGMissionTarget):IsAlive() == nil) then --(Group.getByName(AGMissionTarget):getSize() == 0) then
			--GROUP NOT VALID
			trigger.action.setUserFlag(ScenarioNumber,4)
			NumberOfCompletedMissions = NumberOfCompletedMissions + 1
			AGMissionTarget = nil
			AGMissionBriefingText = nil
			SEF_MissionSelector()						
		else
			--Done looping as something unexpected has happened
			trigger.action.outText("Warning - Mission Validation Unexpected Result In Group Size", 15)						
		end		
	elseif (AGTargetTypeStatic == true and AGMissionTarget ~= nil) then
		--TARGET IS STATIC				
		if (StaticObject.getByName(AGMissionTarget) and StaticObject.getByName(AGMissionTarget):isExist() == true) then
				--STATIC IS VALID
				trigger.action.outSound('That Is Our Target.ogg')
				trigger.action.outText(AGMissionBriefingText,15)								
		else
				--STATIC TARGET NOT VALID, ALREADY DESTROYED
				trigger.action.setUserFlag(ScenarioNumber,4)
				NumberOfCompletedMissions = NumberOfCompletedMissions + 1	
				AGMissionTarget = nil
				AGMissionBriefingText = nil
				SEF_MissionSelector()			
		end		
	else
		--Do nothing
		trigger.action.outText("Warning - Mission Validation Unavailable, No Valid Targets", 15)
	end
end
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////SCENARIOS

function SEF_MissionStarter( MissionNumber )
	--Pick up the initiating mission number
	ScenarioNumber = MissionNumber
		

	if (ScenarioNumber == 1) then
				
		AGMissionTarget = "RUSSIAN PEACEKEEPER COMPOUND"
		AGTargetTypeStatic = false
		AGMissionBriefingText = "MISSION ORDERS \n\n  FLIGHT HAWK (A-10C) PRIMARY TARGET : search and destroy 2 russian columns incoming from Roki tunnel\n- WPT1 commence search of russian column from Djava\n- WPT2 - WPT3 follow road Djava-Roki to WPT4 (Roki Tunnel)\nSECONDARY TARGET: destroy any russian ground unit on road from DJAVA ARMY BASE to  GUFTA BRIDGE (WPT7) \n \nFLIGHT ENFIELD  (HARRIER)\nPRIMARY TARGET: clean up the assigned areas by ENEMY SAM\n- WPT1 : destroy GUFTA BRIDGE and Shilka in the vicinity \n- WPT2 : destroy DJAVA ARMY BASE  and SAM in the vicinity\nSECONDARY TARGET: destroy any russian ground unit on road from DJAVA FARP to  GUFTA BRIDGE\n \nFLIGHT COLT  (F-18)\nPRIMARY TARGET: \n- WPT1 attack all units inside Russian peacekeeper compound (GREEN FLAG FOR FLIGHT SPRINGFIELD)\n- WPT2 destroy Russian Howitzer battery at Galuanta village\nSECONDARY TARGET: destroy any russian ground unit in the vicinity of  RUSSIAN COMPOUND (WPT1)\n \nFLIGHT  FORD (F16) and  CHEVY (F18)\nPRIMARY TARGET: \n-CAP EAST ZONE (WPT1) -  CAP WEAST ZONE (WPT2):Intercept ALL Russian bombers attacking attacking our airbases : beware of possible escort aircraft!!!\nSECONDARY TARGET: search and destroy any russian HELICOPTER \n \nFLIGHT SPRINGFIELD  (UH1H)\nPRIMARY TARGET: load ranger groups and transport them inside russian compound (WPT3) ; WAIT FOR GREEN FLAG FROM FLIGHT COLT!!!"
	--	trigger.action.setUserFlag(771,1)
		    		
		--Group Activations - Primary NO / Secondary YES / Ambient YES 
		--trigger.action.activateGroup(Group.getByName("T72 Russian column"))
		--trigger.action.activateGroup(Group.getByName("Objective 1 Ambient"))
		
		--////Set Flags For Support Services: 1 = CAP, 2 = CAS, 3 = Anti-Ship, 4 = SEAD, 5 = Pinpoint Strike
		--trigger.action.setUserFlag(5001,1)
		--trigger.action.setUserFlag(5002,1)
		--trigger.action.setUserFlag(5003,0)
		--trigger.action.setUserFlag(5004,1)
		--trigger.action.setUserFlag(5005,1)
		
							
	else
		-- Unexpected output
		trigger.action.outText("Mission Start Error",30)
	end	
end

--////End Scenarios
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


function MissionSuccess() -- To be triggered on AG Mission Successful
	
	AGMissionTarget = nil
	AGMissionBriefingText = nil
	
	local RandomMissionSuccessSound = math.random(1,5)
	trigger.action.outSound('AG Kill ' .. RandomMissionSuccessSound .. '.ogg')
		
	--////Set All Support Service Flags To 0 To Switch Them All Off
	--trigger.action.setUserFlag(5001,0)
	--trigger.action.setUserFlag(5002,0)
	--trigger.action.setUserFlag(5003,0)
	--trigger.action.setUserFlag(5004,0)
	--trigger.action.setUserFlag(5005,0)	
end

local function CheckObjectiveRequest()
	
	if (AGMissionBriefingText ~= nil) then
		trigger.action.outText(AGMissionBriefingText, 30)
		trigger.action.outSound('That Is Our Target.ogg')
	else
		trigger.action.outText("There are no current objectives", 15)
	end	
end

function TargetReport()
			
	if (AGTargetTypeStatic == false and AGMissionTarget ~=nil) then
		TargetGroup = GROUP:FindByName(AGMissionTarget)	
		
		if (GROUP:FindByName(AGMissionTarget):IsAlive() == true) then
		
			TargetRemainingUnits = Group.getByName(AGMissionTarget):getSize()	
			
			MissionPlayersBlue = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterOnce()
			
			MissionPlayersBlue:ForEachClient(
				function(Client)
					if Client:IsAlive() == true then
						ClientPlayerName = Client:GetPlayerName()	  
						ClientUnitName = Client:GetName()			  
						ClientGroupName = Client:GetClientGroupName() 			
						ClientGroupID = Client:GetClientGroupID()	   	
				
						PlayerGroup = GROUP:FindByName(ClientGroupName) 
					
						PlayerCoord = PlayerGroup:GetCoordinate()
						TargetCoord = TargetGroup:GetCoordinate()
						TargetHeight = math.floor(TargetGroup:GetCoordinate():GetLandHeight() * 100)/100
						PlayerDistance = PlayerCoord:Get2DDistance(TargetCoord)

						TargetVector = PlayerCoord:GetDirectionVec3(TargetCoord)
						TargetBearing = PlayerCoord:GetAngleRadians (TargetVector)	
					
						PlayerBR = PlayerCoord:GetBRText(TargetBearing, PlayerDistance, SETTINGS:SetImperial())
					
						--List the amount of units remaining in the group
						if (TargetRemainingUnits > 1) then
							SZMessage = "There are "..TargetRemainingUnits.." targets remaining for this mission" 
						elseif (TargetRemainingUnits == 1) then
							SZMessage = "There is "..TargetRemainingUnits.." target remaining for this mission" 
						elseif (TargetRemainingUnits == nil) then					
							SZMessage = "Unable To Determine Group Size"
						else			
							SZMessage = "Nothing to report"		
						end		
					
						BRMessage = "Target bearing "..PlayerBR
						ELEMessage = "Elevation "..TargetHeight.."m"
					
						CoordStringLLDMS = TargetCoord:ToStringLLDMS(SETTINGS:SetImperial())
						CoordStringLLDDM = TargetCoord:ToStringLLDDM(SETTINGS:SetImperial())
					
						trigger.action.outTextForGroup(ClientGroupID, AGMissionBriefingText.."\n"..BRMessage.."\n"..SZMessage.."\n"..CoordStringLLDMS.."\n"..CoordStringLLDDM.."\n"..ELEMessage, 30)							
					else
						--Do nothing
					end				
				end
			)
		else
			trigger.action.outText("Target Report Unavailable", 15)
		end
		
	elseif (AGTargetTypeStatic == true and AGMissionTarget ~=nil) then
		TargetGroup = STATIC:FindByName(AGMissionTarget, false)
		
		MissionPlayersBlue = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterOnce()

		MissionPlayersBlue:ForEachClient(
			function(Client)
				if Client:IsAlive() == true then
					ClientPlayerName = Client:GetPlayerName()	
					ClientUnitName = Client:GetName()			
					ClientGroupName = Client:GetClientGroupName()				
					ClientGroupID = Client:GetClientGroupID()
				
					PlayerGroup = GROUP:FindByName(ClientGroupName) 
					
					PlayerCoord = PlayerGroup:GetCoordinate()
					TargetCoord = TargetGroup:GetCoordinate()
					TargetHeight = math.floor(TargetGroup:GetCoordinate():GetLandHeight() * 100)/100
					PlayerDistance = PlayerCoord:Get2DDistance(TargetCoord)
					
					TargetVector = PlayerCoord:GetDirectionVec3(TargetCoord)
					TargetBearing = PlayerCoord:GetAngleRadians (TargetVector)	
										
					PlayerBR = PlayerCoord:GetBRText(TargetBearing, PlayerDistance, SETTINGS:SetImperial())

					BRMessage = "Target bearing "..PlayerBR
					ELEMessage = "Elevation "..TargetHeight.."m"
					
					CoordStringLLDMS = TargetCoord:ToStringLLDMS(SETTINGS:SetImperial())
					CoordStringLLDDM = TargetCoord:ToStringLLDDM(SETTINGS:SetImperial())
					
					trigger.action.outTextForGroup(ClientGroupID, AGMissionBriefingText.."\n"..BRMessage.."\n"..CoordStringLLDMS.."\n"..CoordStringLLDDM.."\n"..ELEMessage, 30)							
				else
					--Do nothing
				end				
			end
		)		
	else
		trigger.action.outText("No Target Information Available", 15)
	end
end

--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////SUPPORT FUNCTIONS

--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////Radio Menu 

--function RadioMenuSetup()
	--////Set Up Menu
	-- table missionCommands.addSubMenuForCoalition(enum coalition.side, string name , table path)
	-- table missionCommands.addCommand(string name, table/nil path, function functionToRun , any anyArguement)
	-- table missionCommands.addCommandForCoalition(enum coalition.side, string name, table/nil path, function functionToRun , any anyArguement)
	
	 --////Setup Submenu For Support Requests
 -- SupportMenuMain = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request Support", nil)
 -- SupportMenuAbort = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Abort Directives", nil)

	--////Setup Menu Option To Get The Current Objective
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Check Current Objective", nil, function() CheckObjectiveRequest() end, nil)
	--////Target Report to get target numbers and coordinates 
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Target Report", nil, function() TargetReport() end, nil)
	
	--//// Mission Options
	--missionOptions = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "mission Options", nil)
	--missionSkipScenario  = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Skip This Mission", missionOptions, function() SEF_SkipScenario() end, nil)	
	

--end

--////End Radio Menu Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////Mission Scheduled Functions

function SEF_MissionTargetStatus(TimeLoop, time)

	if (AGTargetTypeStatic == false and AGMissionTarget ~= nil) then
		--TARGET IS NOT STATIC
					
		if (GROUP:FindByName(AGMissionTarget):IsAlive() == true) then
			--GROUP STILL ALIVE
			--trigger.action.outText("Mission Update - Target Group Remains Alive", 15)
			
			return time + 10			
		elseif (GROUP:FindByName(AGMissionTarget):IsAlive() == false or GROUP:FindByName(AGMissionTarget):IsAlive() == nil) then 
			--GROUP DEAD
			trigger.action.outText("Mission Update - Mission Successful", 15)
			trigger.action.setUserFlag(ScenarioNumber,4)
			NumberOfCompletedMissions = NumberOfCompletedMissions + 1
			MissionSuccess()
			timer.scheduleFunction(SEF_MissionSelector, {}, timer.getTime() + 20)
			
			return time + 30			
		else
			--Done looping as something unexpected has happened
			trigger.action.outText("Warning - Mission Status Unexpected Result, Monitor Stopped", 15)			
			
			--return time + 10			
		end		
	elseif (AGTargetTypeStatic == true and AGMissionTarget ~= nil) then
		--TARGET IS STATIC
				
		if (StaticObject.getByName(AGMissionTarget) and StaticObject.getByName(AGMissionTarget):isExist() == true) then
				--STATIC ALIVE
				--trigger.action.outText("Target Exists", 15) -- Shows when the static is alive
				--trigger.action.outText("Mission Update - Target Structure Remains Alive", 15)
			
				return time + 10				
		else
				--trigger.action.outText("Target Does Not Exist", 15) -- Shows when static is destroyed
				
				--STATIC DESTROYED	
				trigger.action.outText("Mission Update - Mission Successful", 15)
				trigger.action.setUserFlag(ScenarioNumber,4)
				NumberOfCompletedMissions = NumberOfCompletedMissions + 1
				MissionSuccess()
				timer.scheduleFunction(SEF_MissionSelector, {}, timer.getTime() + 20)
			
				return time + 30				
		end		
	else
		--Do nothing
		return time + 10
	end	
end

--////End Mission Scheduled Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////Override Functions



function SEF_SkipScenario()	
	--Check mission is not suddenly flagged as state 4 (Completed)
	if ( trigger.misc.getUserFlag(ScenarioNumber) >= 1 and trigger.misc.getUserFlag(ScenarioNumber) <= 3 ) then
		-- Reset the mission to be 'not started', clear the target information and reroll a new scenario
		trigger.action.setUserFlag(ScenarioNumber,0) 
		AGMissionTarget = nil
		AGMissionBriefingText = nil
		SEF_MissionSelector()
	else
		--Do nothing as mission must be in a completion state
		trigger.action.outText("Unable To Skip As Current Mission Is In A Completion State", 15)
	end
end

function SEF_ToggleFiringSounds()

	if ( OnShotSoundsEnabled == 0 ) then
		--Turn it on
		OnShotSoundsEnabled = 1
		trigger.action.outText("Firing Sounds Are Now Enabled", 15)
	elseif ( OnShotSoundsEnabled == 1 ) then
		--Turn it off
		OnShotSoundsEnabled = 0
		trigger.action.outText("Firing Sounds Are Now Disabled", 15)
	else
		--Do nothing
	end
end

--////End Override Functions

--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////MAIN

if ( trigger.misc.getUserFlag(1000) == 0 ) then
  
  NumberOfCompletedMissions = 0
  BlueAirDefence = 0
  OnShotSoundsEnabled = 1
  SoundLockout = 0  
  
  _SETTINGS:SetPlayerMenuOff()
  _SETTINGS:SetImperial()
  
  --First time running, immediately enable missions, and choose a mission
  trigger.action.setUserFlag(1000,1) 
  
  --////Enable CAP/CAS/ASS/SEAD/PIN
  trigger.action.setUserFlag(5001,1)
  trigger.action.setUserFlag(5002,1)
  trigger.action.setUserFlag(5003,1)
  trigger.action.setUserFlag(5004,1)
  trigger.action.setUserFlag(5005,1)
  
  --////Enable attacks from RED Bombers
  trigger.action.setUserFlag(5006,1)
  
  SEF_MissionSelector()
  RadioMenuSetup()
  SEF_BLUEAwacsSpawn()
  SEF_BLUETexacoSpawn()
  SEF_BLUEShellSpawn()
  SEF_CarrierDefenceZone()  
  --Start Scheduler to check mission target status
  timer.scheduleFunction(SEF_MissionTargetStatus, 53, timer.getTime() + 10)
  --Start Scheduler for red bomber attacks, wait 10-15 minutes before starting
  timer.scheduleFunction(SEF_RedBomberScheduler, 53, timer.getTime() + math.random(600, 900))
  --Initialise Carrier Defence Scanner, wait 5 minutes before starting
  timer.scheduleFunction(SEF_CarrierDefenceZoneScanner, 53, timer.getTime() + 300)  
  
elseif ( trigger.misc.getUserFlag(1000) > 0 ) then
  --This should never get run
  --At least 1 mission has completed, select mission with delay to allow sounds to play outSound
  MissionSuccess()  
else
  -- Do nothing
end